Main Page Modules Class Hierarchy Data Structures File List Data Fields Globals Related Pages

# oscl_mem.h File Reference

This file contains basic memory definitions for common use across platforms. More...

`#include "osclconfig_memory.h"`
`#include "oscl_base.h"`
`#include "oscl_types.h"`
`#include "oscl_assert.h"`
`#include "oscl_mem_basic_functions.h"`
`#include "oscl_lock_base.h"`
`#include "osclconfig_compiler_warnings.h"`
`#include "oscl_mem_inst.h"`
`#include "oscl_heapbase.h"`
`#include "oscl_defalloc.h"`
`#include "oscl_refcounter.h"`
`#include "oscl_error.h"`
`#include "oscl_exception.h"`
`#include "oscl_mem.inl"`

Go to the source code of this file.

## Data Structures
class | HeapBase
class | OsclAuditCB
class | OsclMem
class | OsclMemAllocator
class | OsclMemAllocDestructDealloc
class | OsclMemBasicAllocator
class | OsclMemBasicAllocDestructDealloc
class | OsclMemGlobalAuditObject
## Defines
#define | OSCL_DISABLE_WARNING_TRUNCATE_DEBUG_MESSAGE
#define | OSCL_HAS_GLOBAL_NEW_DELETE 1
#define | OSCL_CLEANUP_BASE_CLASS(T) _OSCL_CLEANUP_BASE_CLASS(T)
#define | OSCL_ALLOC_NEW(T_allocator, T, params) new(T_allocator.allocate(1)) T params
#define | OSCL_TRAP_ALLOC_NEW(T_ptr, T_allocator, T, params) _OSCL_TRAP_NEW(T_allocator.allocate(1),T_allocator.deallocate,T_ptr,T,params)
#define | OSCL_ALLOC_DELETE(ptr, T_allocator, T)
#define | OSCL_MALLOC(count) _oscl_default_audit_malloc(count)
#define | oscl_malloc(a) OSCL_MALLOC(a)
#define | OSCL_DEFAULT_MALLOC(x) OSCL_MALLOC(x)
#define | OSCL_AUDIT_MALLOC(auditCB, count) _oscl_audit_malloc(count, auditCB)
#define | OSCL_CALLOC(num, size) _oscl_default_audit_calloc(num,size)
#define | oscl_calloc(a, b) OSCL_CALLOC(a,b)
#define | OSCL_AUDIT_CALLOC(auditCB, num, size) _oscl_audit_calloc(num,size, auditCB)
#define | OSCL_REALLOC(ptr, new_size) _oscl_default_audit_realloc(ptr,new_size)
#define | oscl_realloc(a, b) OSCL_REALLOC(a,b)
#define | OSCL_AUDIT_REALLOC(auditCB, ptr, new_size) _oscl_audit_realloc(ptr,new_size, auditCB)
#define | OSCL_FREE(ptr) _oscl_audit_free(ptr)
#define | oscl_free(x) OSCL_FREE(x)
#define | OSCL_DEFAULT_FREE(x) OSCL_FREE(x)
#define | OSCL_NEW(T, params) new T params
#define | OSCL_PLACEMENT_NEW(ptr, constructor) new(ptr) constructor
#define | OSCL_TRAP_NEW(T_ptr, T, params) _OSCL_TRAP_NEW(_oscl_default_audit_new(sizeof(T)),_oscl_audit_free,T_ptr,T,params)
#define | OSCL_AUDIT_NEW(auditCB, T, params) new(_oscl_audit_new(sizeof(T),auditCB)) T params
#define | OSCL_TRAP_AUDIT_NEW(T_ptr, auditCB, T, params) _OSCL_TRAP_NEW(_oscl_audit_new(sizeof(T),auditCB),_oscl_audit_free,T_ptr,T,params)
#define | OSCL_DELETE(ptr)
#define | OSCL_AUDIT_ARRAY_NEW(auditCB, T, count) new(_oscl_audit_new(sizeof(T)*(count),auditCB)) T
#define | OSCL_ARRAY_NEW(T, count) new T[count]
#define | OSCL_ARRAY_DELETE(ptr) delete [] ptr
#define | OSCL_DISABLE_WARNING_TRUNCATE_DEBUG_MESSAGE
#define | _OSCL_TRAP_NEW(exp, freeFunc, T_ptr, T, params)
#define | _OSCL_CLEANUP_BASE_CLASS(T) this->T::~T()
## Functions
OSCL_COND_IMPORT_REF uint | oscl_mem_aligned_size (uint size)
OSCL_IMPORT_REF void | OsclMemInit (OsclAuditCB &auditCB)
OSCL_IMPORT_REF void * | _oscl_audit_malloc (size_t, OsclAuditCB &, const char *f=NULL, const int l=0)
OSCL_IMPORT_REF void * | _oscl_audit_calloc (size_t, size_t, OsclAuditCB &, const char *f=NULL, const int l=0)
OSCL_IMPORT_REF void * | _oscl_audit_realloc (void *, size_t, OsclAuditCB &, const char *f=NULL, const int l=0)
OSCL_IMPORT_REF void * | _oscl_audit_new (size_t, OsclAuditCB &, const char *f=NULL, const int l=0)
OSCL_IMPORT_REF void * | _oscl_default_audit_malloc (size_t, const char *f=NULL, const int l=0)
OSCL_IMPORT_REF void * | _oscl_default_audit_calloc (size_t, size_t, const char *f=NULL, const int l=0)
OSCL_IMPORT_REF void * | _oscl_default_audit_realloc (void *, size_t, const char *f=NULL, const int l=0)
OSCL_IMPORT_REF void * | _oscl_default_audit_new (size_t, const char *f=NULL, const int l=0)
OSCL_IMPORT_REF void | _oscl_audit_free (void *)
void * | operator new (size_t aSize, const char *aFile, int aLine)
void * | operator new (size_t aSize)
void | operator delete (void *aPtr)
void * | operator new[] (size_t aSize, const char *aFile, int aLine)
void * | operator new[] (size_t aSize)
void | operator delete[] (void *aPtr)

## Detailed Description

This file contains basic memory definitions for common use across platforms.

This is the main entry point header file for the OSCL memory library. It should be the only one users directly include. Basic memory copy, compare, and move functions are defined here as well as the allocation functions.

## Define Documentation

#define OSCL_DISABLE_WARNING_TRUNCATE_DEBUG_MESSAGE

| Previously this was in oscl_mem_imp.h

## Function Documentation

void operator delete | ( | void * | aPtr | ) | `[inline]`

void* operator new | ( | size_t | aSize | ) | `[inline]`